/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.EsquemaTramo;
import com.rjconsultores.ventaboletos.entidad.ParadaEsquema;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Label;
import org.zkoss.zul.Timebox;
import org.zkoss.zul.api.Spinner;

/**
 *
 * @author Administrador
 */
@Controller("tiempoEstanciaEsquemaTramoController")
@Scope("prototype")
public class TiempoEstanciaEsquemaTramoController extends MyGenericForwardComposer {

    private MyListbox esquemaTramoList;
    private EsquemaTramo esquemaTramo;
    private ParadaEsquema paradaEsquema;
    private Label lbTramo;
    private Spinner spHora;
    private Spinner spMinuto;

    public Label getLbTramo() {
        return lbTramo;
    }

    public void setLbTramo(Label lbTramo) {
        this.lbTramo = lbTramo;
    }

    public EsquemaTramo getEsquemaTramo() {
        return esquemaTramo;
    }

    public void setEsquemaTramo(EsquemaTramo esquemaTramo) {
        this.esquemaTramo = esquemaTramo;
    }

    public ParadaEsquema getParadaEsquema() {
        return paradaEsquema;
    }

    public void setParadaEsquema(ParadaEsquema paradaEsquema) {
        this.paradaEsquema = paradaEsquema;
    }

    public Spinner getSpHora() {
        return spHora;
    }

    public void setSpHora(Spinner spHora) {
        this.spHora = spHora;
    }

    public Spinner getSpMinuto() {
        return spMinuto;
    }

    public void setSpMinuto(Spinner spMinuto) {
        this.spMinuto = spMinuto;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        esquemaTramo = (EsquemaTramo) Executions.getCurrent().getArg().get("esquemaTramo");
        paradaEsquema = (ParadaEsquema) Executions.getCurrent().getArg().get("paradaEsquema");
        esquemaTramoList = (MyListbox) Executions.getCurrent().getArg().get("esquemaTramoList");

        String parada = paradaEsquema.getParada().getCveparada();
        String tramo = esquemaTramo.getTramo().getDesctramo();
        lbTramo.setValue(parada);

        if (esquemaTramo.getTiempoEstancia() != null) {
            Calendar c = Calendar.getInstance();
            c.setTime(esquemaTramo.getTiempoEstancia());
            System.out.println(DateUtil.getFecInicio().getTime() + " " + c.getTime());
            Long tempo = DateUtil.getElapsedMinutos(DateUtil.getFecInicio().getTime(), c.getTime());
            Long minutos = (tempo % 60);
            int horas = (tempo.intValue() / 60);

            spMinuto.setValue(minutos.intValue());
            spHora.setValue(horas);
        }
    }

    public void onClick$btnCerrar(Event ev) {
        closeWindow();
    }

    public void onClick$btnSalvar(Event ev) {
        spHora.getValue();
        spMinuto.getValue();

        esquemaTramo.setTiempoEstancia(DateUtil.getFecInicio(spHora.getValue(), spMinuto.getValue()).getTime());
        paradaEsquema.setTiempoEstancia(DateUtil.getFecInicio(spHora.getValue(), spMinuto.getValue()).getTime());

        esquemaTramoList.updateItem(paradaEsquema);

        closeWindow();
    }
}
