/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional.generaciontramosrutas;

import com.rjconsultores.ventaboletos.entidad.Ruta;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Window;

import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.TramoRutaService;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.vo.esquemaoperacional.RutaTramoVO;
import com.rjconsultores.ventaboletos.web.gui.componente.esquemaoperacional.GridRutaTramo;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

/**
 * 
 * @author Administrador
 */
@Controller("editarCombinacionTramoRutaController")
@Scope("prototype")
public class EditarCombinacionTramoRutaController extends MyGenericForwardComposer {

	@Autowired
	private ViaService viaService;
	@Autowired
	private TramoRutaService tramoRutaService;
	private RutaTramoVO rutaTramoIdaVO;
	private RutaTramoVO rutaTramoRegresoVO;
	private GridRutaTramo gridRutaSecuenciaIda;
	private GridRutaTramo gridRutaSecuenciaVolta;
	private Window winEditarTramoRuta;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		rutaTramoIdaVO = (RutaTramoVO) Executions.getCurrent().getArg().get("rutaTramoVO");
		winEditarTramoRuta = (Window) Executions.getCurrent().getArg().get("winEditarTramoRuta");
		super.doAfterCompose(comp);
		gridRutaSecuenciaIda.setMostraPopupGrid(false);
		gridRutaSecuenciaIda.setClaseServicio(rutaTramoIdaVO.getClaseServicio());
		gridRutaSecuenciaIda.setLsVias(viaService.obtenerTodos());
		gridRutaSecuenciaIda.agregarTodos(tramoRutaService.generarCombinacion(rutaTramoIdaVO));
		gridRutaSecuenciaVolta.setMostraPopupGrid(false);
		gridRutaSecuenciaVolta.setClaseServicio(rutaTramoIdaVO.getClaseServicio());
		gridRutaSecuenciaVolta.setLsVias(viaService.obtenerTodos());
	}

	public void onClick$btnSalvar(Event e) throws InterruptedException {
		rutaTramoIdaVO.setLsCombinacionRutaTramoVO(gridRutaSecuenciaIda.getLsSecuenciaRutaTramoVO());

		try {
			Ruta rutaIda = tramoRutaService.generarTramosRutas(rutaTramoIdaVO);

			if (rutaIda != null) {

				Messagebox.show(Labels.getLabel("editarCombinacionTramoRutaController.MSG.rutaIdaGenerada",
						new Object[] { rutaIda.getRutaId() + " - " + rutaIda.getDescruta() }),
						Labels.getLabel("editarCombinacionTramoRutaController.window.title"), Messagebox.OK, Messagebox.INFORMATION);

				if (!gridRutaSecuenciaVolta.isEmpty()) {
					int resp = Messagebox.show(Labels.getLabel("editarCombinacionTramoRutaController.MSG.generarRutaRegreso"),
							Labels.getLabel("editarCombinacionTramoRutaController.window.title"), Messagebox.YES | Messagebox.NO,
							Messagebox.QUESTION);

					if (resp == Messagebox.YES) {
						rutaTramoRegresoVO.setLsCombinacionRutaTramoVO(gridRutaSecuenciaVolta.getLsSecuenciaRutaTramoVO());
						Ruta rutaRegresso = tramoRutaService.generarTramosRutas(rutaTramoRegresoVO);

						if (rutaRegresso != null) {
							Messagebox.show(Labels.getLabel("editarCombinacionTramoRutaController.MSG.rutaRegresoGenerada",
									new Object[] { rutaRegresso.getRutaId() + " - " + rutaRegresso.getDescruta() }),
									Labels.getLabel("editarCombinacionTramoRutaController.window.title"), Messagebox.OK, Messagebox.INFORMATION);
						}
					}
				}
			}

			winEditarTramoRuta.detach();
			this.closeWindow();
		} catch (BusinessException e1) {
			Messagebox.show(e1.getMessage(), Labels.getLabel("editarCombinacionTramoRutaController.window.title"), Messagebox.OK,
					Messagebox.ERROR);
		}

	}

	public void onClick$btnRutaRegreso(Event e) {
		rutaTramoIdaVO.setLsCombinacionRutaTramoVO(gridRutaSecuenciaIda.getLsSecuenciaRutaTramoVO());
		rutaTramoRegresoVO = tramoRutaService.generarRutaRegreso(rutaTramoIdaVO);

		gridRutaSecuenciaVolta.agregarTodos(rutaTramoRegresoVO.getLsCombinacionRutaTramoVO());
	}
}
