/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional.generaciontramosrutas;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Window;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.RutaEmpresa;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.TramoRutaService;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.vo.esquemaoperacional.RutaTramoVO;
import com.rjconsultores.ventaboletos.web.gui.componente.esquemaoperacional.GridRutaTramo;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 * 
 * @author Administrador
 */
@Controller("editarTramoRutaController")
@Scope("prototype")
public class EditarTramoRutaController extends MyGenericForwardComposer {
	@Autowired
	private ViaService viaService;
	@Autowired
	private ClaseServicioService claseServicioService;
	@Autowired
	private TramoRutaService tramoRutaService;
	@Autowired
	private EmpresaService empresaService;
	private List<ClaseServicio> lsClaseServicio;
	private List<Empresa> lsEmpresa;
	private Combobox cmbClaseServicio;
	private Checkbox chkVentaHandHeld;
	private Checkbox chkSolicitaNombrePasajero;
	private Textbox txtDscRuta;
	private Window winEditarTramoRuta;
	private Combobox cmbEmpresa;
	private MyListbox rutaEmpresaList;
	private GridRutaTramo gridRutaSecuencia;
	private List<Empresa> lsRutaEmpresa;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsClaseServicio = claseServicioService.obtenerTodos();
		lsEmpresa = empresaService.obtenerIndTipo1();
		lsRutaEmpresa = new ArrayList<Empresa>();
		super.doAfterCompose(comp);
		gridRutaSecuencia.setLsVias(viaService.obtenerTodos());
	}

	public void onClick$btnCombinacion(Event e) throws InterruptedException {

		if (lsRutaEmpresa.isEmpty()) {
			Messagebox.show(Labels.getLabel("editarTramoRutaController.msg.empresaObligatoria"),
					Labels.getLabel("editarTramoRutaController.window.title"), Messagebox.OK, Messagebox.INFORMATION);

			return;
		}

		RutaTramoVO rutaTramoVO = new RutaTramoVO();
		rutaTramoVO.setClaseServicio((ClaseServicio) cmbClaseServicio.getSelectedItem().getValue());
		rutaTramoVO.setSolicitaNombrePasajero(chkSolicitaNombrePasajero.isChecked());
		rutaTramoVO.setVentaHandHeld(chkVentaHandHeld.isChecked());
		rutaTramoVO.setLsSecuenciaRutaTramoVO(gridRutaSecuencia.getLsSecuenciaRutaTramoVO());
		rutaTramoVO.setLsEmpresa(lsRutaEmpresa);

		Map<String, Object> params = new LinkedHashMap<String, Object>();
		params.put("rutaTramoVO", rutaTramoVO);
		params.put("winEditarTramoRuta", winEditarTramoRuta);

		this.openWindow("/gui/esquema_operacional/generacion_tramo_ruta/editarCombinacionTramoRuta.zul",
				Labels.getLabel("editarCombinacionTramoRutaController.window.title"), params, MODAL);

	}

	public void onClick$btnAgregarPaso(Event e) {
		cmbClaseServicio.getValue();
		Map<String, Object> params = new LinkedHashMap<String, Object>();
		params.put("gridRutaSecuencia", gridRutaSecuencia);
		params.put("origen", gridRutaSecuencia.getUltimaParada());
		params.put("txtDscRuta", txtDscRuta);

		this.openWindow("/gui/esquema_operacional/generacion_tramo_ruta/nuevaParada.zul",
				Labels.getLabel("nuevaParadaController.window.title"), params, MODAL);
	}

	public List<ClaseServicio> getLsClaseServicio() {
		return lsClaseServicio;
	}

	public void onChange$cmbClaseServicio(Event e) {
		gridRutaSecuencia.setClaseServicio((ClaseServicio) cmbClaseServicio.getSelectedItem().getValue());
	}

	public void onClick$btnDebugCombinacion(Event e) {
		RutaTramoVO rutaTramoVO = new RutaTramoVO();
		rutaTramoVO.setClaseServicio((ClaseServicio) cmbClaseServicio.getSelectedItem().getValue());
		rutaTramoVO.setSolicitaNombrePasajero(chkSolicitaNombrePasajero.isChecked());
		rutaTramoVO.setVentaHandHeld(chkVentaHandHeld.isChecked());
		rutaTramoVO.setLsSecuenciaRutaTramoVO(gridRutaSecuencia.getLsSecuenciaRutaTramoVO());

		tramoRutaService.generarCombinacion(rutaTramoVO);
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void onClick$btnAdicionarEmpresaRuta(Event ev) throws InterruptedException {

		Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();

		if (cbiEmpresa != null) {
			Empresa empresa = (Empresa) cbiEmpresa.getValue();

			if (!lsRutaEmpresa.contains(empresa)) {
				lsRutaEmpresa.add(empresa);
				rutaEmpresaList.setData(lsRutaEmpresa);
			} else {
				Messagebox.show(Labels.getLabel("MSG.Registro.Existe"), Labels.getLabel("editarTramoRutaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		}

	}

	public void onClick$btnRemoverEmpresaRuta(Event ev) {
		Empresa rutaEmpresa = (Empresa) rutaEmpresaList.getSelected();
		if (rutaEmpresa != null) {
			lsRutaEmpresa.remove(rutaEmpresa);
			rutaEmpresaList.setData(lsRutaEmpresa);
		}
	}
}
