package com.rjconsultores.ventaboletos.web.gui.controladores.ingreso;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoEventoExtra;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaTipoEventoExtraController")
@Scope("prototype")
public class BusquedaTipoEventoExtraController extends MyGenericForwardComposer {

	@Autowired
	private transient PagedListWrapper<TipoEventoExtra> plwTipoEventoExtra;
	@Autowired
	private EmpresaService empresaService;
	private List<Empresa> lsEmpresa;
	private MyListbox tipoEventoExtraList;
	private Paging pagingTipoEventoExtra;
	// private Intbox idTipoEventoExtra;
	private Textbox txtNombre;
	private Combobox cmbIndOperacion;

	public Combobox getCmbIndOperacion() {
		return cmbIndOperacion;
	}

	public void setCmbIndOperacion(Combobox cmbIndOperacion) {
		this.cmbIndOperacion = cmbIndOperacion;
	}

	public MyListbox getTipoEventoExtraList() {
		return tipoEventoExtraList;
	}

	public void setTipoEventoExtraList(MyListbox tipoEventoExtraList) {
		this.tipoEventoExtraList = tipoEventoExtraList;
	}

	public Paging getPagingTipoEventoExtra() {
		return pagingTipoEventoExtra;
	}

	public void setPagingTipoEventoExtra(Paging pagingTipoEventoExtra) {
		this.pagingTipoEventoExtra = pagingTipoEventoExtra;
	}

	public PagedListWrapper<TipoEventoExtra> getPlwTipoEventoExtra() {
		return plwTipoEventoExtra;
	}

	public void setPlwTipoEventoExtra(
			PagedListWrapper<TipoEventoExtra> plwTipoEventoExtra) {
		this.plwTipoEventoExtra = plwTipoEventoExtra;
	}

	public Textbox getTxtNombre() {
		return txtNombre;
	}

	public void setTxtNombre(Textbox txtNombre) {
		this.txtNombre = txtNombre;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new TipoEventoExtra());
	}

	public EmpresaService getEmpresaService() {
		return empresaService;
	}

	public void setEmpresaService(EmpresaService empresaService) {
		this.empresaService = empresaService;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		
		lsEmpresa = empresaService.buscarTodosExceto(-1);
		
		super.doAfterCompose(comp);

		tipoEventoExtraList.setItemRenderer(new RenderTipoEventoExtra());
		tipoEventoExtraList.addEventListener("onDoubleClick",
				new EventListener() {

					@Override
					public void onEvent(Event event) throws Exception {
						TipoEventoExtra emp = (TipoEventoExtra) tipoEventoExtraList
								.getSelected();
						verPeriodo(emp);
					}
				});

		refreshLista();

		txtNombre.focus();
	}

	private void verPeriodo(TipoEventoExtra emp) {
		if (emp == null) {
			return;
		}

		Map args = new HashMap();
		args.put("tipoEventoExtra", emp);
		args.put("tipoEventoExtraList", tipoEventoExtraList);

		openWindow(
				"/gui/ingreso/editarTipoEventoExtra.zul",
				Labels.getLabel("editarTipoEventoExtraController.window.title"),
				args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<TipoEventoExtra> tipoEventoExtraBusqueda = new HibernateSearchObject<TipoEventoExtra>(TipoEventoExtra.class, pagingTipoEventoExtra.getPageSize());

		tipoEventoExtraBusqueda.addFilterLike("descTipoEvento", "%" + txtNombre.getText().trim().concat("%"));
		if (cmbIndOperacion.getSelectedItem() != null) {
			tipoEventoExtraBusqueda.addFilterEqual("indoperacion", Short.parseShort(cmbIndOperacion.getSelectedItem().getValue().toString()));
		}
		tipoEventoExtraBusqueda.addFilterEqual("activo", Boolean.TRUE);
		tipoEventoExtraBusqueda.addSortAsc("descTipoEvento");
		

		plwTipoEventoExtra.init(tipoEventoExtraBusqueda, tipoEventoExtraList, pagingTipoEventoExtra);

		if (tipoEventoExtraList.getData().length == 0) {
			try {
				Messagebox
						.show(Labels.getLabel("MSG.ningunRegistro"),
								Labels.getLabel("busquedaTipoEventoExtraController.window.title"),
								Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
}
