/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Estacion;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEstacion;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Longbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaEstacionController")
@Scope("prototype")
public class BusquedaEstacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Estacion> plwEstacion;
    @Autowired
    private PuntoVentaService puntoVentaService;
    private List<PuntoVenta> lsPuntoVenta;
    private MyListbox estacionList;
    private Paging pagingEstacion;
    private Textbox txtDescEstacion;
    //private Textbox txtDescMac;
    private Combobox cmbPuntoVenta;
    private Longbox txtNumCaja;
    private static Logger log = Logger.getLogger(BusquedaEstacionController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsPuntoVenta = new ArrayList<PuntoVenta>();

        super.doAfterCompose(comp);

        estacionList.setItemRenderer(new RenderEstacion());
        estacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Estacion s = (Estacion) estacionList.getSelected();
                verEstacion(s);
            }
        });

        refreshLista();

        txtDescEstacion.focus();
    }

    private void verEstacion(Estacion e) {
        if (e == null) {
            return;
        }

        Map args = new HashMap();
        args.put("estacion", e);
        args.put("estacionList", estacionList);

        openWindow("/gui/seguridad/editarEstacion.zul",
                Labels.getLabel("editarEstacionController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Estacion> estacionBusqueda =
                new HibernateSearchObject<Estacion>(Estacion.class,
                pagingEstacion.getPageSize());

        estacionBusqueda.addFilterLike("descestacion",
                "%" + txtDescEstacion.getText().trim().concat("%"));
//        estacionBusqueda.addFilterLike("descmac",
//                "%" + txtDescMac.getText().trim().concat("%"));

        Comboitem cbiPuntoVenta = cmbPuntoVenta.getSelectedItem();
        if (cbiPuntoVenta != null) {
            PuntoVenta pv = (PuntoVenta) cbiPuntoVenta.getValue();
            estacionBusqueda.addFilterEqual("puntoVenta", pv);
        }

        estacionBusqueda.addFilterEqual("numcaja", txtNumCaja.getValue());

        estacionBusqueda.addSortAsc("descestacion");
        estacionBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwEstacion.init(estacionBusqueda, estacionList, pagingEstacion);

        if (estacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("editarEstacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
                log.error(ex);
                Clients.alert(Labels.getLabel("MSG.Error"), Labels.getLabel("editarEstacionController.window.title"), Messagebox.INFORMATION);
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verEstacion(new Estacion());
    }
}
