/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.media.Media;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Filedownload;
import org.zkoss.zhtml.Fileupload;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Tab;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.MercadoCompetidoService;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TarifaCategoriaService;
import com.rjconsultores.ventaboletos.service.TarifaService;
import com.rjconsultores.ventaboletos.service.TarifaTipoptovtaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCatalogoDeRutas;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCategoria;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderClaseServicio;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEmpresaModificacionMassivaTarifa;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMarca;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMoneda;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderVigenciaTarifaModificacionMassivaTarifa;

/**
 *
 * @author rodrigo
 */
@Controller("modificacionMasivaTarifasController")
@Scope("prototype")
public class ModificacionMasivaTarifasController extends MyGenericForwardComposer {

    private final Integer CELL_ID_TARIFA = 0;
    private final Integer CELL_NOVO_PRECIO = 8;
    private final Integer CELL_ID_CATEGORIA = 10;
    private final Integer CELL_NOVO_PRECIO_CATEGORIA = 12;
    private final Integer CELL_ID_TIPO_PUNTO = 14;
    private final Integer CELL_NOVO_PRECIO_TIPO_PUNTO = 16;
    @Autowired
    private TarifaService tarifaService;
    @Autowired
    private TarifaCategoriaService tarifaCategoriaService;
    @Autowired
    private TarifaTipoptovtaService tarifaTipoptovtaService;
    @Autowired
    private MarcaService marcaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private MonedaService monedaService;
    @Autowired
    private MercadoCompetidoService mercadoCompetidoService;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private RutaService rutaService;
    @Autowired
    private TipoPuntoVentaService tipoPuntoVentaService;
    @Autowired
    private CategoriaService categoriaService;
    @Autowired
    private VigenciaTarifaService vigenciaTarifaService;
    private List<Marca> lsMarcas;
    private List<ClaseServicio> lsClaseServico;
    private List<Moneda> lsMonedas;
    private List<Empresa> lsEmpresas;
    private List<Ruta> lsRutas;
    private List<TipoPuntoVenta> lsTipoPuntoVenta;
    private List<Categoria> lsCategoria;
    private List<VigenciaTarifa> lsVigenciaTarifa;
    private List<Marca> lsAddRmvMarcas;
    private List<ClaseServicio> lsAddRmvClaseServico;
    private List<Moneda> lsAddRmvMonedas;
    private List<Empresa> lsAddRmvEmpresas;
    private List<Ruta> lsAddRmvRutas;
    private List<TipoPuntoVenta> lsAddRmvTipoPuntoVenta;
    private List<Categoria> lsAddRmvCategoria;
    private List<VigenciaTarifa> lsAddRmvVigenciaTarifa;
    private Combobox cmbMarca;
    private Combobox cmbMoneda;
    private Combobox cmbClaseServicio;
    private Combobox cmbEmpresa;
    private Combobox cmbRuta;
    private Combobox cmbTipoPuntoVenta;
    private Combobox cmbCategoria;
    private Combobox cmbVigenciaTarifa;
    private MyListbox claseServicioList;
    private MyListbox marcaList;
    private MyListbox monedaList;
    private MyListbox empresaList;
    private MyListbox rutaList;
    private MyListbox tipoPuntoVentaList;
    private MyListbox categoriaList;
    private MyListbox vigenciaTarifaList;
    private Textbox txtPorcentagem;
    private Radio radIncremento;
    private Radio radDecremento;
    private Button btnGerarTarifas;
    private Tab tabTipoPuntoVenta;
    private Tab tabCategoria;
    private static Logger log = Logger.getLogger(ModificacionMasivaTarifasController.class);

    public List<ClaseServicio> getLsClaseServico() {
        return lsClaseServico;
    }

    public void setLsClaseServico(List<ClaseServicio> lsClaseServico) {
        this.lsClaseServico = lsClaseServico;
    }

    public List<Marca> getLsMarcas() {
        return lsMarcas;
    }

    public void setLsMarcas(List<Marca> lsMarcas) {
        this.lsMarcas = lsMarcas;
    }

    public List<Moneda> getLsMonedas() {
        return lsMonedas;
    }

    public void setLsMonedas(List<Moneda> lsMonedas) {
        this.lsMonedas = lsMonedas;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public Combobox getCmbMarca() {
        return cmbMarca;
    }

    public void setCmbMarca(Combobox cmbMarca) {
        this.cmbMarca = cmbMarca;
    }

    public Combobox getCmbMoneda() {
        return cmbMoneda;
    }

    public void setCmbMoneda(Combobox cmbMoneda) {
        this.cmbMoneda = cmbMoneda;
    }

    public Textbox getTxtPorcentagem() {
        return txtPorcentagem;
    }

    public void setTxtPorcentagem(Textbox txtPorcentagem) {
        this.txtPorcentagem = txtPorcentagem;
    }

    public Radio getRadDecremento() {
        return radDecremento;
    }

    public void setRadDecremento(Radio radDecremento) {
        this.radDecremento = radDecremento;
    }

    public Radio getRadIncremento() {
        return radIncremento;
    }

    public void setRadIncremento(Radio radIncremento) {
        this.radIncremento = radIncremento;
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public List<Empresa> getLsEmpresas() {
        return lsEmpresas;
    }

    public void setLsEmpresas(List<Empresa> lsEmpresas) {
        this.lsEmpresas = lsEmpresas;
    }

    public Combobox getCmbRuta() {
        return cmbRuta;
    }

    public void setCmbRuta(Combobox cmbRuta) {
        this.cmbRuta = cmbRuta;
    }

    public List<Ruta> getLsRutas() {
        return lsRutas;
    }

    public void setLsRutas(List<Ruta> lsRutas) {
        this.lsRutas = lsRutas;
    }

    public Combobox getCmbCategoria() {
        return cmbCategoria;
    }

    public void setCmbCategoria(Combobox cmbCategoria) {
        this.cmbCategoria = cmbCategoria;
    }

    public Combobox getCmbTipoPuntoVenta() {
        return cmbTipoPuntoVenta;
    }

    public void setCmbTipoPuntoVenta(Combobox cmbTipoPuntoVenta) {
        this.cmbTipoPuntoVenta = cmbTipoPuntoVenta;
    }

    public List<Categoria> getLsCategoria() {
        return lsCategoria;
    }

    public void setLsCategoria(List<Categoria> lsCategoria) {
        this.lsCategoria = lsCategoria;
    }

    public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
        return lsTipoPuntoVenta;
    }

    public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
        this.lsTipoPuntoVenta = lsTipoPuntoVenta;
    }

    public Combobox getCmbVigenciaTarifa() {
        return cmbVigenciaTarifa;
    }

    public void setCmbVigenciaTarifa(Combobox cmbVigenciaTarifa) {
        this.cmbVigenciaTarifa = cmbVigenciaTarifa;
    }

    public List<VigenciaTarifa> getLsVigenciaTarifa() {
        return lsVigenciaTarifa;
    }

    public void setLsVigenciaTarifa(List<VigenciaTarifa> lsVigenciaTarifa) {
        this.lsVigenciaTarifa = lsVigenciaTarifa;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        super.doAfterCompose(comp);

        lsMarcas = marcaService.obtenerTodos();
        lsClaseServico = claseServicioService.obtenerTodos();
        lsMonedas = monedaService.obtenerTodos();
        lsEmpresas = empresaService.obtenerIndTipo1();
        lsRutas = rutaService.obtenerTodos();
        lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
        lsCategoria = categoriaService.obtenerTodos();
        lsVigenciaTarifa = vigenciaTarifaService.obtenerTodos();

        claseServicioList.setItemRenderer(new RenderClaseServicio());
        marcaList.setItemRenderer(new RenderMarca());
        monedaList.setItemRenderer(new RenderMoneda());
        empresaList.setItemRenderer(new RenderEmpresaModificacionMassivaTarifa());
        rutaList.setItemRenderer(new RenderCatalogoDeRutas());
        tipoPuntoVentaList.setItemRenderer(new RenderTipoPuntoVenta());
        categoriaList.setItemRenderer(new RenderCategoria());
        vigenciaTarifaList.setItemRenderer(new RenderVigenciaTarifaModificacionMassivaTarifa());

        lsAddRmvMarcas = new ArrayList<Marca>();
        lsAddRmvClaseServico = new ArrayList<ClaseServicio>();
        lsAddRmvMonedas = new ArrayList<Moneda>();
        lsAddRmvEmpresas = new ArrayList<Empresa>();
        lsAddRmvRutas = new ArrayList<Ruta>();
        lsAddRmvTipoPuntoVenta = new ArrayList<TipoPuntoVenta>();
        lsAddRmvCategoria = new ArrayList<Categoria>();
        lsAddRmvVigenciaTarifa = new ArrayList<VigenciaTarifa>();

        // eliminando a opcao TODOS de tipo servicio:
        Short shortMinus1 = -1;
        ClaseServicio claseServicioTodos = claseServicioService.obtenerID(shortMinus1);
        if (claseServicioTodos != null) {
            lsClaseServico.remove(claseServicioTodos);
        }

        //Exibir botão para gerar tarifas automaticas
        btnGerarTarifas.setVisible(ApplicationProperties.getInstance().generarTarifasAutomatica());

        //Abas desativadas no SCIA
        tabCategoria.setVisible(Boolean.FALSE);
        tabTipoPuntoVenta.setVisible(Boolean.FALSE);

    }

    private void validarTodos() {
        Short shortMinus1 = -1;

        ClaseServicio claseServicioTodos = claseServicioService.obtenerID(shortMinus1);
        if (claseServicioTodos != null) {
            if (lsClaseServico.contains(claseServicioTodos)) {
                lsClaseServico = claseServicioService.obtenerTodos();
            }
        }

        Marca marcaTodos = marcaService.obtenerID(shortMinus1);
        if (marcaTodos != null) {
            if (lsMarcas.contains(marcaTodos)) {
                lsMarcas = marcaService.obtenerTodos();
            }
        }

        TipoPuntoVenta tpvTodos = tipoPuntoVentaService.obtenerID(shortMinus1);
        if (tpvTodos != null) {
            if (lsTipoPuntoVenta.contains(tpvTodos)) {
                lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
            }
        }

        Categoria categoriaTodos = categoriaService.obtenerID(-1);
        if (categoriaTodos != null) {
            if (lsCategoria.contains(categoriaTodos)) {
                lsCategoria = categoriaService.obtenerTodos();
            }
        }

        VigenciaTarifa vigenciaTarifaTodos = vigenciaTarifaService.obtenerID(-1);
        if (vigenciaTarifaTodos != null) {
            if (lsVigenciaTarifa.contains(vigenciaTarifaTodos)) {
                lsVigenciaTarifa = vigenciaTarifaService.obtenerTodos();
            }
        }

        Moneda monedaTodos = monedaService.obtenerID(-1);
        if (monedaTodos != null) {
            if (lsMonedas.contains(monedaTodos)) {
                lsMonedas = monedaService.obtenerTodos();
            }
        }

        Empresa empresaTodos = empresaService.obtenerID(-1);
        if (empresaTodos != null) {
            if (lsEmpresas.contains(empresaTodos)) {
                lsEmpresas = empresaService.obtenerTodos();
            }
        }

        Ruta rutaTodos = rutaService.obtenerID(-1);
        if (rutaTodos != null) {
            if (lsRutas.contains(rutaTodos)) {
                lsRutas = rutaService.obtenerTodos();
            }
        }
    }

    public void onClick$btnGerarExcel(Event ev) {
        txtPorcentagem.getValue();

        try {
            if (lsAddRmvVigenciaTarifa.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("modificacionMasivaTarifasController.MSG.SemVigencia"),
                        Labels.getLabel("modificacionMasivaTarifasController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);

                return;
            }

            BigDecimal coeficiente = new BigDecimal(BigInteger.ZERO);
            try {
                if (txtPorcentagem.getValue() != null) {

                    BigDecimal porcentage = BigDecimal.valueOf(Double.parseDouble(txtPorcentagem.getValue()));

                    coeficiente = porcentage.divide(new BigDecimal(100));
                    if (radIncremento.isChecked()) {
                        coeficiente = coeficiente.add(BigDecimal.ONE);
                    } else {
                        coeficiente = BigDecimal.ONE.subtract(coeficiente);
                    }
                }
            } catch (Exception e) {
                log.debug("Porcentagem Zero");
            }

            if (coeficiente == null) {
                return;
            }

            //TESTE:
            //List<Tarifa> lsTarifa = tarifaService.obtenerTodos();
            validarTodos();
            List<Tarifa> lsTarifa = tarifaService.pesquisar(lsAddRmvMonedas, lsAddRmvMarcas,
                    lsAddRmvClaseServico, lsAddRmvCategoria, lsAddRmvEmpresas, lsAddRmvRutas,
                    lsAddRmvTipoPuntoVenta, lsAddRmvVigenciaTarifa);

            Workbook wb = new SXSSFWorkbook(500);

            // fonte em negrito:
            Font fonte = wb.createFont();
            fonte.setBoldweight(Font.BOLDWEIGHT_BOLD);
            CellStyle estilo = wb.createCellStyle();
            estilo.setFont(fonte);

            Sheet sheet1 = wb.createSheet(
                    Labels.getLabel("modificacionMasivaTarifasController.window.title"));

            Row rowCabecalho = sheet1.createRow(0);

            Cell cell = rowCabecalho.createCell(0);
            cell.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhId.label"));
            cell.setCellStyle(estilo);

            Cell cell0 = rowCabecalho.createCell(1);
            cell0.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhTramo.label"));
            cell0.setCellStyle(estilo);

            Cell cell1 = rowCabecalho.createCell(2);
            cell1.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhMarca.label"));
            cell1.setCellStyle(estilo);

            Cell cell2 = rowCabecalho.createCell(3);
            cell2.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhClaseServicio.label"));
            cell2.setCellStyle(estilo);

            Cell cell3 = rowCabecalho.createCell(4);
            cell3.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhFeciniciovigencia.label"));
            cell3.setCellStyle(estilo);

            Cell cell4 = rowCabecalho.createCell(5);
            cell4.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhMoneda.label"));
            cell4.setCellStyle(estilo);

            //Preco original I - 6
            Cell cell5 = rowCabecalho.createCell(6);
            cell5.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhPrecioOriginal.label"));
            cell5.setCellStyle(estilo);

            // j - 6
            Cell cell6 = rowCabecalho.createCell(7);
            cell6.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhPrecioExcel.label"));
            cell6.setCellStyle(estilo);

            //I - 8
            Cell cell7 = rowCabecalho.createCell(8);
            cell7.setCellValue(
                    Labels.getLabel("busquedaTarifaController.lhPrecioNuevo.label"));
            cell7.setCellStyle(estilo);


            for (int i = 0; i < lsTarifa.size(); i++) {

                Tarifa tarifa = lsTarifa.get(i);

                Row row = sheet1.createRow(i + 1);

                row.createCell(0).setCellValue(tarifa.getTarifaId());
                row.createCell(1).setCellValue(tarifa.getTramo().getDesctramo());
                row.createCell(2).setCellValue(tarifa.getMarca().getDescmarca());
                row.createCell(3).setCellValue(tarifa.getClaseServicio().getDescclase());
                row.createCell(4).setCellValue(tarifa.getVigenciaTarifa().toString());
                row.createCell(5).setCellValue(tarifa.getMoneda().getDescmoneda());
                row.createCell(6).setCellValue(tarifa.getPreciooriginal().setScale(2).doubleValue());
                row.createCell(7).setCellValue(tarifa.getPrecio().setScale(2).doubleValue());

                // novo preco:
                BigDecimal novoPrecio = tarifa.getPrecio();
                novoPrecio = novoPrecio.multiply(coeficiente).setScale(2, RoundingMode.HALF_UP);

                Cell cellNovoPrecio = row.createCell(8);
                cellNovoPrecio.setCellValue(novoPrecio.setScale(2).doubleValue());
                cellNovoPrecio.setCellStyle(estilo);

                //Tipo de Pasajero
                row.createCell(9).setCellValue("");
                row.createCell(10).setCellValue("");
                row.createCell(11).setCellValue("");
                row.createCell(12).setCellValue("");

                // novo preco CANAL VENTA:
                row.createCell(13).setCellValue("");
                row.createCell(14).setCellValue("");
                row.createCell(15).setCellValue("");
                row.createCell(16).setCellValue("");
            }
//            }

            String nomeArquivo =
                    UsuarioLogado.getUsuarioLogado().getNombusuario()
                    + "_" + Calendar.getInstance().getTime().getTime()
                    + "_" + "modMassivaT.xlsx";

            FileOutputStream stream = new FileOutputStream(nomeArquivo);
            stream.flush();
            wb.write(stream);
            stream.close();

            InputStream is = null;
            is = new FileInputStream(nomeArquivo);
            Filedownload.save(is, "application/xlsx", "modificacionMasivaTarifa.xlsx");

            boolean success = (new File(nomeArquivo)).delete();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public VigenciaTarifa vigenciaTarifa(Media mExcel) throws IOException {
        InputStream isMExcel = mExcel.getStreamData();
        Workbook wb = new XSSFWorkbook(isMExcel);

        VigenciaTarifa v = new VigenciaTarifa();

        for (int k = 0; k < wb.getNumberOfSheets(); k++) {
            Sheet sheet = wb.getSheetAt(k);
            int rows = sheet.getPhysicalNumberOfRows();

            // pula o row 0 pq eh o cabecalho:
            for (int r = 1; r < rows; r++) {
                Row row = sheet.getRow(r);
                if (row == null) {
                    continue;
                }

                Cell cellIdTarifa = row.getCell(CELL_ID_TARIFA);
                BigDecimal bdId = new BigDecimal(cellIdTarifa.getNumericCellValue());
                Integer idTarifa = bdId.intValue();

                Tarifa tarifa = tarifaService.obtenerID(idTarifa);

                v = tarifa.getVigenciaTarifa();

                break;
            }
        }
        return v;
    }

    public void onClick$btnUpLoadExcel(Event ev) throws InterruptedException,
            IOException {
        Media mExcel = Fileupload.get();

        if (mExcel != null) {
            Map args = new HashMap();
            args.put("mExcel", mExcel);

            openWindow("/gui/tarifas/modificacionMasivaTarifasUpload.zul",
                    Labels.getLabel("modificacionMasivaTarifasController.window.title"), args, MODAL);

        }
    }

    public void onClick$btnGerarTarifas(Event ev) {

        Map args = new HashMap();

        openWindow("/gui/tarifas/generarTarifa.zul",
                Labels.getLabel("modificacionMasivaTarifasController.window.title"), args, MODAL);
    }

    public void onClick$btnAdicionarClaseServicio(Event ev) {
        Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
        if (cbiClaseServicio != null) {
            ClaseServicio claseServicio = (ClaseServicio) cbiClaseServicio.getValue();

            lsAddRmvClaseServico.add(claseServicio);
            claseServicioList.setData(lsAddRmvClaseServico);

            cmbClaseServicio.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverClaseServicio(Event ev) {
        ClaseServicio claseServicio = (ClaseServicio) claseServicioList.getSelected();
        if (claseServicio != null) {
            lsAddRmvClaseServico.remove(claseServicio);
            claseServicioList.setData(lsAddRmvClaseServico);
        }
    }

    public void onClick$btnAdicionarMarca(Event ev) {
        Comboitem cbimarca = cmbMarca.getSelectedItem();
        if (cbimarca != null) {
            Marca marca = (Marca) cbimarca.getValue();

            lsAddRmvMarcas.add(marca);
            marcaList.setData(lsAddRmvMarcas);

            cmbMarca.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverMarca(Event ev) {
        Marca marca = (Marca) marcaList.getSelected();
        if (marca != null) {
            lsAddRmvMarcas.remove(marca);
            marcaList.setData(lsAddRmvMarcas);
        }
    }

    public void onClick$btnAdicionarMoneda(Event ev) {
        Comboitem cbiMoneda = cmbMoneda.getSelectedItem();
        if (cbiMoneda != null) {
            Moneda moneda = (Moneda) cbiMoneda.getValue();

            lsAddRmvMonedas.add(moneda);
            monedaList.setData(lsAddRmvMonedas);

            cmbMoneda.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverMoneda(Event ev) {
        Moneda moneda = (Moneda) monedaList.getSelected();
        if (moneda != null) {
            lsAddRmvMonedas.remove(moneda);
            monedaList.setData(lsAddRmvMonedas);
        }
    }

    public void onClick$btnAdicionarEmpresa(Event ev) {
        Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        if (cbiEmpresa != null) {
            Empresa empresa = (Empresa) cbiEmpresa.getValue();

            lsAddRmvEmpresas.add(empresa);
            empresaList.setData(lsAddRmvEmpresas);

            cmbEmpresa.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverEmpresa(Event ev) {
        Empresa empresa = (Empresa) empresaList.getSelected();
        if (empresa != null) {
            lsAddRmvEmpresas.remove(empresa);
            empresaList.setData(lsAddRmvEmpresas);
        }
    }

    public void onClick$btnAdicionarRuta(Event ev) {
        Comboitem cbiRuta = cmbRuta.getSelectedItem();
        if (cbiRuta != null) {
            Ruta ruta = (Ruta) cbiRuta.getValue();

            lsAddRmvRutas.add(ruta);
            rutaList.setData(lsAddRmvRutas);

            cmbRuta.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverRuta(Event ev) {
        Ruta ruta = (Ruta) rutaList.getSelected();
        if (ruta != null) {
            lsAddRmvRutas.remove(ruta);
            rutaList.setData(lsAddRmvRutas);
        }
    }

    public void onClick$btnAdicionarTipoPuntoVenta(Event ev) {
        Comboitem cbiTipoPuntoVenta = cmbTipoPuntoVenta.getSelectedItem();
        if (cbiTipoPuntoVenta != null) {
            TipoPuntoVenta tipoPuntoVenta = (TipoPuntoVenta) cbiTipoPuntoVenta.getValue();

            lsAddRmvTipoPuntoVenta.add(tipoPuntoVenta);
            tipoPuntoVentaList.setData(lsAddRmvTipoPuntoVenta);

            cmbTipoPuntoVenta.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverTipoPuntoVenta(Event ev) {
        TipoPuntoVenta tipoPuntoVenta = (TipoPuntoVenta) tipoPuntoVentaList.getSelected();
        if (tipoPuntoVenta != null) {
            lsAddRmvTipoPuntoVenta.remove(tipoPuntoVenta);
            tipoPuntoVentaList.setData(lsAddRmvTipoPuntoVenta);
        }
    }

    public void onClick$btnAdicionarCategoria(Event ev) {
        Comboitem cbiCategoria = cmbCategoria.getSelectedItem();
        if (cbiCategoria != null) {
            Categoria categoria = (Categoria) cbiCategoria.getValue();

            lsAddRmvCategoria.add(categoria);
            categoriaList.setData(lsAddRmvCategoria);

            cmbCategoria.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverCategoria(Event ev) {
        Categoria categoria = (Categoria) categoriaList.getSelected();
        if (categoria != null) {
            lsAddRmvCategoria.remove(categoria);
            categoriaList.setData(lsAddRmvCategoria);
        }
    }

    public void onClick$btnAdicionarVigenciaTarifa(Event ev) {
        Comboitem cbiVigenciaTarifa = cmbVigenciaTarifa.getSelectedItem();
        if (cbiVigenciaTarifa != null) {
            VigenciaTarifa vigenciaTarifa = (VigenciaTarifa) cbiVigenciaTarifa.getValue();

            lsAddRmvVigenciaTarifa.add(vigenciaTarifa);
            vigenciaTarifaList.setData(lsAddRmvVigenciaTarifa);

            cmbVigenciaTarifa.setSelectedItem(null);
        }
    }

    public void onClick$btnRemoverVigenciaTarifa(Event ev) {
        VigenciaTarifa vigenciaTarifa = (VigenciaTarifa) vigenciaTarifaList.getSelected();
        if (vigenciaTarifa != null) {
            lsAddRmvVigenciaTarifa.remove(vigenciaTarifa);
            vigenciaTarifaList.setData(lsAddRmvVigenciaTarifa);
        }
    }
}
