/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.media.Media;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Filedownload;
import org.zkoss.zul.Label;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.MercadoCompetido;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.MercadoCompetidoService;
import com.rjconsultores.ventaboletos.service.TarifaCategoriaService;
import com.rjconsultores.ventaboletos.service.TarifaService;
import com.rjconsultores.ventaboletos.service.TarifaTipoptovtaService;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

/**
 *
 * @author Rafius
 */
@Controller("modificacionMasivaTarifasUploadController")
@Scope("prototype")
public class ModificacionMasivaTarifasUploadController extends MyGenericForwardComposer {

    private final Integer CELL_ID_TARIFA = 0;
    private final Integer CELL_NOVO_PRECIO = 8;
    private final Integer CELL_ID_CATEGORIA = 10;
    private final Integer CELL_NOVO_PRECIO_CATEGORIA = 12;
    private final Integer CELL_ID_TIPO_PUNTO = 14;
    private final Integer CELL_NOVO_PRECIO_TIPO_PUNTO = 16;
    @Autowired
    private TarifaService tarifaService;
    @Autowired
    private VigenciaTarifaService vigenciaTarifaService;
    @Autowired
    private MercadoCompetidoService mercadoCompetidoService;
    @Autowired
    private TarifaCategoriaService tarifaCategoriaService;
    @Autowired
    private TarifaTipoptovtaService tarifaTipoptovtaService;
    private List<VigenciaTarifa> lsVigenciaTarifa;
    private VigenciaTarifa vigenciaTarifa;
    private Media mExcel;
    private Radio rdVigenciaAtual;
    private Radio rdVigenciaNueva;
    private Combobox cmbVigenciaTarifa;
    private Label lbVigencia;
    private static Logger log = Logger.getLogger(ModificacionMasivaTarifasUploadController.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        super.doAfterCompose(comp);

        mExcel = (Media) Executions.getCurrent().getArg().get("mExcel");

        lsVigenciaTarifa = vigenciaTarifaService.obtenerTodos();
        lbVigencia.setVisible(Boolean.FALSE);
        cmbVigenciaTarifa.setVisible(Boolean.FALSE);

        vigenciaTarifa();

    }

    public void onClick$rdVigenciaNueva(Event ev) {
        lbVigencia.setVisible(Boolean.TRUE);
        cmbVigenciaTarifa.setVisible(Boolean.TRUE);
        cmbVigenciaTarifa.setConstraint("no empty");
    }

    public void onClick$rdVigenciaAtual(Event ev) {
        lbVigencia.setVisible(Boolean.FALSE);
        cmbVigenciaTarifa.setVisible(Boolean.FALSE);
        cmbVigenciaTarifa.setConstraint("");
    }

    public void onClick$btnSalvar(Event ev) throws IOException, InterruptedException {
        if (rdVigenciaAtual.isChecked()) {
            salvarNuevos(false);
        } else {
            cmbVigenciaTarifa.getValue();
            salvarNuevos(true);
        }

    }

    public void salvarNuevos(Boolean salvarNuevos) throws IOException, InterruptedException {

        String strErrorTarifa = "";
        String strMercadoCompetido = "";
        String strTarifaMinima = "";
        String strDuplicidade = "";

        Integer contador = 0;

        Integer opcao = Messagebox.show(
                Labels.getLabel("modificacionMasivaTarifasController.MSGAplicar"),
                Labels.getLabel("modificacionMasivaTarifasController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (opcao.equals(Messagebox.YES)) {
            InputStream isMExcel = mExcel.getStreamData();
            Workbook wb = new XSSFWorkbook(isMExcel);

            for (int k = 0; k < wb.getNumberOfSheets(); k++) {
                Sheet sheet = wb.getSheetAt(k);
                int rows = sheet.getPhysicalNumberOfRows();

                // pula o row 0 pq eh o cabecalho:
                for (int r = 1; r < rows; r++) {
                    Row row = sheet.getRow(r);
                    if (row == null) {
                        continue;
                    }

                    Cell cellIdTarifa = row.getCell(CELL_ID_TARIFA);
                    BigDecimal bdId = new BigDecimal(cellIdTarifa.getNumericCellValue());
                    Integer idTarifa = bdId.intValue();

                    Tarifa tarifa = tarifaService.obtenerID(idTarifa);

                    if (tarifa != null) {
                        Tramo tramo = tarifa.getTramo();
                        if (tramo != null) {
                            Parada origem = tarifa.getTramo().getOrigem();
                            Ciudad ciudad = origem.getCiudad();
                            Plaza plaza = null;
                            if (ciudad != null) {
                                plaza = ciudad.getPlaza();
                            }
                            Parada destino = tarifa.getTramo().getDestino();
                            ClaseServicio claseServicio = tarifa.getClaseServicio();
                            Moneda moneda = tarifa.getMoneda();
                            Via via = tramo.getVia();

                            // verificando se a tarifa eh de um mercado competido:
                            boolean existeMercadoCompetido = mercadoCompetidoService.existe(claseServicio, origem, destino);
                            if (!existeMercadoCompetido) {
                                try {
                                    Cell cellNovoPrecio = row.getCell(CELL_NOVO_PRECIO);
                                    BigDecimal novoPrecio = new BigDecimal(cellNovoPrecio.getNumericCellValue());
                                    novoPrecio = novoPrecio.setScale(2, RoundingMode.HALF_UP);
                                    
                                    
                                    Boolean podeSalvarTarifaMinima =
                                            tarifaService.podeAlterarTarifaMinima(tarifa, tarifa.getMarca(),
                                            origem, destino, claseServicio, plaza, moneda);

                                    if (podeSalvarTarifaMinima) {
                                        if (salvarNuevos) {
                                            Tarifa tarifaNueva = new Tarifa();

                                            tarifaNueva.setClaseServicio(tarifa.getClaseServicio());
                                            tarifaNueva.setMarca(tarifa.getMarca());
                                            tarifaNueva.setMoneda(tarifa.getMoneda());
                                            tarifaNueva.setPrecio(novoPrecio);
                                            tarifaNueva.setPreciooriginal(tarifa.getPreciooriginal());
                                            tarifaNueva.setPrecioredabierto(tarifa.getPrecioredabierto());
                                            tarifaNueva.setStatustarifa("A");
                                            tarifaNueva.setTramo(tarifa.getTramo());

                                            Comboitem cbiVt = cmbVigenciaTarifa.getSelectedItem();
                                            VigenciaTarifa nuevaVigencia = (VigenciaTarifa) cbiVt.getValue();
                                            tarifaNueva.setVigenciaTarifa(nuevaVigencia);

                                            boolean existeTarifa = tarifaService.existe(tarifaNueva.getMarca(), tarifaNueva.getTramo(), tarifaNueva.getMoneda(),
                                                    tarifaNueva.getClaseServicio(), nuevaVigencia);
                                            if (!existeTarifa) {
                                                strDuplicidade = strDuplicidade + "Tarifa ya existente (" + tarifa.getTarifaId() + "). \n";
                                            } else {
                                                tarifa = tarifaService.suscribir(tarifaNueva);
                                            }

                                        } else {
                                        	tarifa.setPrecio(novoPrecio);

                                            tarifa.setStatustarifa("A");

                                            tarifa = tarifaService.actualizacion(tarifa);
                                        }

                                        contador = contador + 1;
                                    } else {
                                        String strTmpTarifaMinima = "TARIFA MINIMA: \n"
                                                + "Tarifa: " + tarifa.getTarifaId() + "; \n"
                                                + "Tramo: " + tramo.getDesctramo() + "; \n"
                                                + "Via: " + tramo.getVia() + "; \n"
                                                + "Clase Servicio: " + claseServicio + "; \n"
                                                + "Precio: " + tarifa.getPrecio().setScale(2).toString() + "\n";

                                        log.info(strTmpTarifaMinima);

                                        strTarifaMinima = strTarifaMinima + strTmpTarifaMinima;
                                    }
                                } catch (IllegalStateException ex) {
                                    String strTmpErrorTarifa = "ERROR: formato nuevo precio." + ex + "\n"
                                            + "Tarifa: " + tarifa.getTarifaId() + "; \n"
                                            + "Tramo: " + tramo.getDesctramo() + "; \n"
                                            + "Via: " + tramo.getVia() + "; \n"
                                            + "Clase Servicio: " + claseServicio + "; \n"
                                            + "Precio: " + tarifa.getPrecio().setScale(2).toString() + "\n";

                                    log.error(strTmpErrorTarifa);

                                    strErrorTarifa = strErrorTarifa + strTmpErrorTarifa;
                                }
                            } else {
                                String strTmpMercadoCompetido = "MERCADO COMPETIDO: \n"
                                        + "Tarifa: " + tarifa.getTarifaId() + "; \n"
                                        + "Tramo: " + tramo.getDesctramo() + "; \n"
                                        + "Via: " + tramo.getVia() + "; \n"
                                        + "Clase Servicio: " + claseServicio + "; \n"
                                        + "Precio: " + tarifa.getPrecio().setScale(2).toString() + "\n";

                                log.info(strTmpMercadoCompetido);

                                strMercadoCompetido = strMercadoCompetido + strTmpMercadoCompetido;
                            }



                        }
                    }

                    //COLUNAS RETIRADAS DO EXCEL
//                    //CATEGORIA
//                    HSSFCell cellIdTarifaCategoria = row.getCell(CELL_ID_CATEGORIA);
//                    if (!cellIdTarifaCategoria.toString().equals("")) {
//                        BigDecimal bdIdCategoria = new BigDecimal(cellIdTarifaCategoria.getNumericCellValue());
//                        Integer idTarifaCategoria = bdIdCategoria.intValue();
//
//                        log.debug("ID - Categoria: " + idTarifaCategoria);
//                        TarifaCategoria tarifaCategoria = tarifaCategoriaService.obtenerID(idTarifaCategoria);
//
//                        if (tarifaCategoria != null) {
//                            HSSFCell cellNovoPrecioCategoria = row.getCell(CELL_NOVO_PRECIO_CATEGORIA);
//                            BigDecimal novoPrecioCategoria = new BigDecimal(cellNovoPrecioCategoria.getNumericCellValue());
//                            tarifaCategoria.setPrecio(novoPrecioCategoria.setScale(2, RoundingMode.HALF_UP));
//                            if (salvarNuevos) {
//                                tarifaCategoriaService.suscribir(tarifaCategoria);
//                            } else {
//                                tarifaCategoriaService.actualizacion(tarifaCategoria);
//                            }
//                        }
//                    }
//                    //PUNTO DE VENTA
//                    HSSFCell cellIdTarifaTipopuntovta = row.getCell(CELL_ID_TIPO_PUNTO);
//                    if (!cellIdTarifaTipopuntovta.toString().equals("")) {
//                        BigDecimal bdIdTipopuntovta = new BigDecimal(cellIdTarifaTipopuntovta.getNumericCellValue());
//                        Integer idTarifaTipopuntovta = bdIdTipopuntovta.intValue();
//
//                        log.debug("ID - TIPO PUNTO DE VENTA: " + idTarifaTipopuntovta);
//                        TarifaTipoptovta tarifaTipopuntovta = tarifaTipoptovtaService.obtenerID(idTarifaTipopuntovta);
//
//                        if (tarifaTipopuntovta != null) {
//                            HSSFCell cellNovoPrecioTipopuntovta = row.getCell(CELL_NOVO_PRECIO_TIPO_PUNTO);
//                            BigDecimal novoPrecioTipopuntovta = new BigDecimal(cellNovoPrecioTipopuntovta.getNumericCellValue());
//                            tarifaTipopuntovta.setPrecio(novoPrecioTipopuntovta.setScale(2, RoundingMode.HALF_UP));
//                            if (salvarNuevos) {
//                                tarifaTipoptovtaService.suscribir(tarifaTipopuntovta);
//                            } else {
//                                tarifaTipoptovtaService.actualizacion(tarifaTipopuntovta);
//                            }
//                        }
//                    }
                }
            }
        }

        if (opcao.equals(Messagebox.YES)) {
            Messagebox.show(
                    Labels.getLabel("modificacionMasivaTarifasController.MSGAplicadoSucesso"),
                    Labels.getLabel("modificacionMasivaTarifasController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            String nomeArquivo =
                    UsuarioLogado.getUsuarioLogado().getNombusuario()
                    + "_" + Calendar.getInstance().getTime().getTime()
                    + "_" + "retorno.txt";

            // Gravando no arquivo de retorno
            File arquivo = new File(nomeArquivo);
            FileOutputStream fos = new FileOutputStream(arquivo);

            String texto = "" + contador + " "
                    + Labels.getLabel("modificacionMasivaTarifasController.MSG.RegistroSalvos") + "\n";

            if (!strTarifaMinima.isEmpty()) {
                texto = texto
                        + "---------- TARIFAS MINIMAS ----------\n"
                        + strTarifaMinima
                        + "\n-------------------------------------\n";
            }

            if (!strMercadoCompetido.isEmpty()) {
                texto = texto
                        + "--------- MERCADO COMPETIDO -----------\n"
                        + strMercadoCompetido
                        + "\n---------------------------------------\n";
            }

            if (!strErrorTarifa.isEmpty()) {
                texto = texto
                        + "--------------- ERRORS ----------------\n"
                        + strErrorTarifa
                        + "\n---------------------------------------";
            }
            if (!strDuplicidade.toString().isEmpty()) {
                log.debug(strDuplicidade);
                texto = texto
                        + "--------------- DUPLICADO ----------------\n"
                        + strDuplicidade
                        + "\n---------------------------------------";
            }

            fos.write(texto.getBytes());
            fos.close();

            InputStream is = null;
            is = new FileInputStream(nomeArquivo);
            Filedownload.save(is, "application/txt", "RetornoModMasivaTarifa.txt");

            boolean success = (new File(nomeArquivo)).delete();

            closeWindow();
        }

    }

    public void vigenciaTarifa() throws IOException, InterruptedException {
        try {
            InputStream isMExcel = mExcel.getStreamData();
            Workbook wb = new XSSFWorkbook(isMExcel);

            for (int k = 0; k < wb.getNumberOfSheets(); k++) {
                Sheet sheet = wb.getSheetAt(k);
                int rows = sheet.getPhysicalNumberOfRows();

                // pula o row 0 pq eh o cabecalho:
                for (int r = 1; r < rows; r++) {
                    Row row = sheet.getRow(r);
                    if (row == null) {
                        continue;
                    }

                    Cell cellIdTarifa = row.getCell(CELL_ID_TARIFA);
                    BigDecimal bdId = new BigDecimal(cellIdTarifa.getNumericCellValue());
                    Integer idTarifa = bdId.intValue();

                    Tarifa tarifa = tarifaService.obtenerID(idTarifa);

                    if (tarifa != null) {

                        VigenciaTarifa v = tarifa.getVigenciaTarifa();
                        vigenciaTarifa = tarifa.getVigenciaTarifa();
                        lsVigenciaTarifa.remove(vigenciaTarifa);

                        SimpleDateFormat sf = new SimpleDateFormat("dd/MM/yyyy HH:mm");

                        log.debug("Vigencia De: " + sf.format(v.getFeciniciovigencia()) + " até: " + sf.format(v.getFecfinvigencia()));

                        rdVigenciaAtual.setLabel(Labels.getLabel("modificacionMasivaTarifasUploadController.MSG.radioUno",
                                new Object[]{sf.format(v.getFeciniciovigencia()).concat(" ").concat(sf.format(v.getFecfinvigencia()))}));
                    }
                    break;
                }
            }
        } catch (Exception e) {
            log.error("Error ao inportar tarifas Excell",e);
            Messagebox.show(
                    Labels.getLabel("modificacionMasivaTarifasUploadController.MSG.excel"),
                    Labels.getLabel("modificacionMasivaTarifasController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
            closeWindow();
        }
    }

    public List<VigenciaTarifa> getLsVigenciaTarifa() {
        return lsVigenciaTarifa;
    }

    public void setLsVigenciaTarifa(List<VigenciaTarifa> lsVigenciaTarifa) {
        this.lsVigenciaTarifa = lsVigenciaTarifa;
    }

    public Media getmExcel() {
        return mExcel;
    }

    public void setmExcel(Media mExcel) {
        this.mExcel = mExcel;
    }

    public Radio getRdVigenciaAtual() {
        return rdVigenciaAtual;
    }

    public void setRdVigenciaAtual(Radio rdVigenciaAtual) {
        this.rdVigenciaAtual = rdVigenciaAtual;
    }

    public Radio getRdVigenciaNueva() {
        return rdVigenciaNueva;
    }

    public void setRdVigenciaNueva(Radio rdVigenciaNueva) {
        this.rdVigenciaNueva = rdVigenciaNueva;
    }

    public Combobox getCmbVigenciaTarifa() {
        return cmbVigenciaTarifa;
    }

    public void setCmbVigenciaTarifa(Combobox cmbVigenciaTarifa) {
        this.cmbVigenciaTarifa = cmbVigenciaTarifa;
    }

    public Label getLbVigencia() {
        return lbVigencia;
    }

    public void setLbVigencia(Label lbVigencia) {
        this.lbVigencia = lbVigencia;
    }
}
